{"openapi":"3.1.0","info":{"title":"Cloud Functions","termsOfService":"https://www.nvidia.com/en-us/legal_info","contact":{"name":"NVIDIA","url":"https://www.nvidia.com/"},"version":"2.232.0"},"servers":[{"url":"https://api.nvcf.nvidia.com","description":"Generated server url"}],"tags":[{"name":"Function Invocation","description":"Defines function pass-through invocation endpoints where the invocation payload  is passed as-is without any wrapper. All the endpoints defined in this API  require a bearer token with 'invoke_function' scope in the HTTP Authorization  header. "},{"name":"Cluster Groups and GPUs","description":"Deprecated. Please use corresponding SIS endpoints directly. These endpoints  will be removed.  Defines endpoints to list Cluster Groups and GPUs for Account Admins. All tne  endpoints defined in this API require a bearer token with 'list_cluster_groups'  scope in the HTTP Authorization header."},{"name":"Asset Management","description":"Deprecated. Users can provide assets directly as part of the input during  function invocation. There is no need to upload assets and then include the  asset-id as part of input to the function invocation.  Defines Asset Management endpoints for Account Admins/Users. All the endpoints  defined in this API require a bearer token in the HTTP Authorization header with  'invoke_function' scope."},{"name":"User Ratelimit Management","description":"Defines User Ratelimit Management endpoints for Account Admins. All the endpoints  defined in this API require a bearer token with 'update_function' scope in  the HTTP Authorization header. "},{"name":"Queue Details","description":"Defines Queue Details endpoints for Account Admins/Users. All the endpoints  defined in this API require a bearer token with 'queue_details' scope in the  HTTP Authorization header. "},{"name":"Function Sharing","description":"Defines endpoints related to authorizing other accounts to invoke a function for  Account Admins. All the endpoints defined in this API require a bearer token with  'authorize_clients' scope in HTTP Authorization header."},{"name":"Telemetry Management","description":"Defines Telemetry Management endpoints for Account Admins. All the endpoints  defined in this API require a bearer token or an api-key with appropriate scope in  the HTTP Authorization header. "},{"name":"Function Deployment","description":"Defines Function Deployment endpoints for Account Admins. All the endpoints defined  in this API require a bearer token with 'deploy_function' scope in the HTTP  Authorization header."},{"name":"User Secret Management","description":"Defines User Secret Management endpoints for Account Admins. All the endpoints  defined in this API require a bearer token with 'update_secrets' scope in  the HTTP Authorization header. "},{"name":"Function Management","description":"Defines Function Management endpoints for Account Admins. All the endpoints  defined in this API require a bearer token with appropriate scope in  the HTTP Authorization header. The scope is specified in the documentation  for each of the endpoints. "},{"name":"Function Invocation Assertion Token","description":"Defines endpoints that issue an assertion token from Notary Service to be used for function invocation later "},{"name":"Registry Credential Management","description":"Defines Registry Credential Management endpoints. These endpoints can only be  invoked by Account Admins and require a bearer token in HTTP Authorization header  with 'manage_registry_credentials' scope. "}],"paths":{"/v2/nvcf/secrets/telemetries/{telemetryId}":{"put":{"tags":["User Secret Management"],"summary":"Update secret for a specific Telemetry Id","description":"Updates secret for the specific telemetry Id within NVIDIA Cloud Account. This endpoint requires a bearer token with 'update_secrets' scope in the HTTP Authorization header. ","operationId":"updateTelemetrySecret","parameters":[{"name":"telemetryId","in":"path","description":"NVIDIA Cloud Account Id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateTelemetrySecretRequest"}}},"required":true},"responses":{"204":{"description":"No Content"}}}},"/v2/nvcf/secrets/functions/{functionId}/versions/{versionId}":{"put":{"tags":["User Secret Management"],"summary":"Update user secrets for a function version","description":"Updates secrets for the specified function version. This endpoint  requires a bearer token with 'update_secrets' scope in the HTTP  Authorization header. ","operationId":"updateFunctionSecrets","parameters":[{"name":"functionId","in":"path","description":"Function Id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"versionId","in":"path","description":"Function Version Id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateFunctionSecretsRequest"}}},"required":true},"responses":{"204":{"description":"No Content"}}}},"/v2/nvcf/ratelimit/functions/{functionId}/versions/{versionId}":{"put":{"tags":["User Ratelimit Management"],"summary":"Update user ratelimit for a function version","description":"Updates ratelimit for the specified function version. This endpoint  requires a bearer token with 'update_function' scope in the HTTP  Authorization header. ","operationId":"updateRateLimit","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"versionId","in":"path","description":"Function version id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateRatelimitRequest"}}},"required":true},"responses":{"204":{"description":"No Content"}}},"delete":{"tags":["User Ratelimit Management"],"summary":"Delete user ratelimit for a function version","description":"Delete ratelimit for the specified function version. This endpoint  requires a bearer token with 'update_function' scope in the HTTP  Authorization header. ","operationId":"deleteRateLimit","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"versionId","in":"path","description":"Function version id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"204":{"description":"No Content"}}}},"/v2/nvcf/metadata/functions/{functionId}/versions/{functionVersionId}":{"put":{"tags":["Function Management"],"summary":"Updates metadata such as tags of the specified function version.","description":"Updates metadata, such as tags, of the specified function version within the authenticated NVIDIA Cloud Account. Values specified in the payload completely override the existing values. Requires a bearer token with 'update_function' scope in the HTTP Authorization header. ","operationId":"updateFunction","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Version id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateFunctionMetadataRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/FunctionResponse"}}}}}}},"/v2/nvcf/deployments/functions/{functionId}/versions/{functionVersionId}":{"get":{"tags":["Function Deployment"],"summary":"Get Function Deployment Details","description":"Allows Account Admins to retrieve the deployment details of the specified  function version. Access to this endpoint mandates a bearer token with 'deploy_function' scope in the  HTTP Authorization header. ","operationId":"getFunctionDeployment","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Function version id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentResponse"}}}}}},"put":{"tags":["Function Deployment"],"summary":"Update Function Deployment","description":" Deprecated and will be removed soon. Use a single GPU specification update  method instead.  Updates the deployment specs of the specified function version. It's important  to note that GPU type and backend configurations cannot be modified through  this endpoint. If the specified function is public, then Account Admin cannot  perform this operation. Access to this endpoint mandates a bearer token with 'deploy_function' scope in the  HTTP Authorization header. ","operationId":"updateFunctionDeployment","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Function version id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateFunctionDeploymentRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentResponse"}}}}},"deprecated":true},"post":{"tags":["Function Deployment"],"summary":"Deploy Function","description":"Initiates deployment for the specified function version. Upon invocation of  this endpoint, the function's status transitions to 'DEPLOYING'. If the  specified function version is public, then Account Admin cannot perform this  operation. Access to this endpoint mandates a bearer token with 'deploy_function' scope in the  HTTP Authorization header. ","operationId":"createFunctionDeployment","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Function version id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/FunctionDeploymentRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentResponse"}}}}}},"delete":{"tags":["Function Deployment"],"summary":"Delete Function Deployment","description":"Deletes the deployment associated with the specified function. Upon  deletion, any active instances will be terminated, and the function's status  will transition to 'INACTIVE'. To undeploy a function version gracefully,  specify 'graceful=true' query parameter, allowing current tasks to complete  before terminating the instances. If the specified function version is public,  then Account Admin cannot perform this operation. Access to this endpoint mandates a bearer token with 'deploy_function' scope in the  HTTP Authorization header. ","operationId":"deleteFunctionDeployment","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Function version id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"graceful","in":"query","description":"Query param to deactivate function for graceful shutdown","required":false,"schema":{"type":"boolean","default":false}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/FunctionResponse"}}}}}}},"/v2/nvcf/tokens/functions":{"post":{"tags":["Function Invocation Assertion Token"],"summary":"Issue Function Invocation Token","description":"Issues an assertion token from Notary Service for specified functionIds and/or functionVersionIds ","operationId":"issueMultiFunctionsInvocationToken","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/MultiFunctionsInvocationTokenRequest"}}},"required":true},"responses":{"200":{"description":"Invocation assertion token is issued","content":{"*/*":{"schema":{"$ref":"#/components/schemas/InvocationTokenResponse"}}}},"403":{"description":"Either missing scope in the auth(SSA JWT / SAK) token and/or missing resource entry\n in the SAK for the function.\n","content":{"*/*":{"schema":{"$ref":"#/components/schemas/InvocationTokenResponse"}}}},"429":{"description":"Client is doing too many requests per second and should slow down request rate.","content":{"*/*":{"schema":{"$ref":"#/components/schemas/InvocationTokenResponse"}}}}}}},"/v2/nvcf/tokens/functions/{functionId}/versions/{functionVersionId}":{"post":{"tags":["Function Invocation Assertion Token"],"summary":"Issue Function Invocation Token","description":"Issues an assertion token from Notary Service for a specific functionId and/or functionVersionId ","operationId":"issueInvocationToken","parameters":[{"name":"functionId","in":"path","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InvocationTokenRequest"}}},"required":true},"responses":{"200":{"description":"Invocation assertion token is issued","content":{"*/*":{"schema":{"$ref":"#/components/schemas/InvocationTokenResponse"}}}},"403":{"description":"Either missing scope in the auth(SSA JWT / SAK) token and/or missing resource entry\n in the SAK for the function.\n","content":{"*/*":{"schema":{"$ref":"#/components/schemas/InvocationTokenResponse"}}}},"429":{"description":"Client is doing too many requests per second and should slow down request rate.","content":{"*/*":{"schema":{"$ref":"#/components/schemas/InvocationTokenResponse"}}}}}}},"/v2/nvcf/tokens/functions/{functionId}":{"post":{"tags":["Function Invocation Assertion Token"],"summary":"Issue Function Invocation Token","description":"Issues an assertion token from Notary Service for a specific functionId and/or functionVersionId ","operationId":"issueInvocationToken_1","parameters":[{"name":"functionId","in":"path","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InvocationTokenRequest"}}},"required":true},"responses":{"200":{"description":"Invocation assertion token is issued","content":{"*/*":{"schema":{"$ref":"#/components/schemas/InvocationTokenResponse"}}}},"403":{"description":"Either missing scope in the auth(SSA JWT / SAK) token and/or missing resource entry\n in the SAK for the function.\n","content":{"*/*":{"schema":{"$ref":"#/components/schemas/InvocationTokenResponse"}}}},"429":{"description":"Client is doing too many requests per second and should slow down request rate.","content":{"*/*":{"schema":{"$ref":"#/components/schemas/InvocationTokenResponse"}}}}}}},"/v2/nvcf/telemetries":{"get":{"tags":["Telemetry Management"],"summary":"List Telemetries","description":"Retrieves telemetry configurations for a specific NVIDIA Cloud Account.  requires a bearer token with 'manage_telemetries' scope in the HTTP  Authorization header. ","operationId":"getTelemetriesByAccount","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ListTelemetryResponse"}}}}}},"post":{"tags":["Telemetry Management"],"summary":"Create Telemetry","description":"Creates telemetry endpoints for NVIDIA Cloud Accounts.  requires a bearer token with 'manage_telemetries' scope in the HTTP  Authorization header. ","operationId":"createTelemetry","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/TelemetryRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TelemetryResponse"}}}}}}},"/v2/nvcf/registry-credentials":{"get":{"tags":["Registry Credential Management"],"summary":"List Registry Credentials","description":"Lists all the registry credentials associated with the authenticated  NVIDIA Cloud Account. Requires a bearer token in the HTTP Authorization header with 'manage_registries' scope. ","operationId":"listRegistryCredentialDetails","parameters":[{"name":"artifactType","in":"query","description":"Filters registry credentials using the specified 'artifactType' query param.\n","required":false,"schema":{"type":"array","default":["CONTAINER","HELM","MODEL","RESOURCE"],"items":{"type":"string","enum":["CONTAINER","HELM","MODEL","RESOURCE"]},"maxItems":2147483647,"minItems":0,"uniqueItems":true}},{"name":"provisionedBy","in":"query","description":"Filters registry credentials using the specified 'provisionedBy' query param.\n","required":false,"schema":{"type":"array","default":["SYSTEM","USER"],"items":{"type":"string","enum":["SYSTEM","USER"]},"maxItems":2147483647,"minItems":0,"uniqueItems":true}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ListRegistryCredentialDetailsResponse"}}}}}},"post":{"tags":["Registry Credential Management"],"summary":"Add new registry credential to the account","description":"Adds a new registry credential to the account. Requires a bearer token in the HTTP Authorization header with 'manage_registries' scope. ","operationId":"addRegistryCredential","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddRegistryCredentialRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RegistryCredentialDetailsResponse"}}}}}}},"/v2/nvcf/pexec/functions/{functionId}":{"post":{"tags":["Function Invocation"],"summary":"Call Function","description":"Deprecated and will be removed soon. Please use the new NVCF Invocation API  endpoint to invoke a function.  Invokes the specified function that was successfully deployed. If the version  is not specified, any active function versions will handle the request. If  the version is specified in the URI, then the request is exclusively processed  by the designated version of the function. By default, this endpoint will block  for 5 seconds. If the request is not fulfilled before the timeout, it's status  is considered in-progress or pending and the response includes HTTP status code  202 with an invocation request ID, indicating that the client should commence  polling for the result using the invocation request ID. Access to this endpoint  mandates inclusion of a bearer token with 'invoke_function' scope in the  HTTP Authorization header. Additionally, this endpoint has the capability to  provide updates on the progress of the request, contingent upon the workload's  provision of such information. In-progress responses are returned in order. If no in-progress response is received  during polling you will receive the most recent in-progress response. Only the first  256 unread in-progress messages are kept. ","operationId":"invokeFunction","parameters":[{"name":"NVCF-INPUT-ASSET-REFERENCES","in":"header","required":false,"schema":{"type":"array","items":{"type":"string"},"maxItems":2147483647,"minItems":0}},{"name":"NVCF-POLL-SECONDS","in":"header","required":false,"schema":{"type":"integer","format":"int32","maximum":300,"minimum":0}},{"name":"functionId","in":"path","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"type":"object"}}},"required":true},"responses":{"200":{"description":"Invocation is fulfilled","headers":{"NVCF-REQID":{"description":"Invocation Request Id","style":"simple","schema":{"type":"string"}},"NVCF-PERCENT-COMPLETE":{"description":"Percentage complete","style":"simple","schema":{"type":"string"}},"NVCF-STATUS":{"description":"Invocation status","style":"simple","schema":{"type":"string"}}},"content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"202":{"description":"Result is pending. Client should poll using the requestId.","headers":{"NVCF-REQID":{"description":"Invocation Request Id","style":"simple","schema":{"type":"string"}},"NVCF-PERCENT-COMPLETE":{"description":"Percentage complete","style":"simple","schema":{"type":"string"}},"NVCF-STATUS":{"description":"Invocation status","style":"simple","schema":{"type":"string"}}},"content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"302":{"description":"Client should use the URL specified in the 'Location' response header to fetch\n large result.\n","headers":{"NVCF-REQID":{"description":"Invocation Request Id","style":"simple","schema":{"type":"string"}},"NVCF-PERCENT-COMPLETE":{"description":"Percentage complete","style":"simple","schema":{"type":"string"}},"NVCF-STATUS":{"description":"Invocation status","style":"simple","schema":{"type":"string"}},"Location":{"description":"URL to get the result","style":"simple","schema":{"type":"string"}}}},"402":{"description":"Cloud credits expired for public functions. Please contact NVIDIA representatives.","content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"403":{"description":"Either missing scope in the auth(SSA JWT / SAK) token and/or missing resource entry\n in the SAK for the function.\n","content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"429":{"description":"Client is doing too many requests per second and should slow down request rate.","content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}}},"deprecated":true}},"/v2/nvcf/pexec/functions/{functionId}/versions/{versionId}":{"post":{"tags":["Function Invocation"],"summary":"Call Function","description":"Deprecated and will be removed soon. Please use the new NVCF Invocation API  endpoint to invoke a function.  Invokes the specified function that was successfully deployed. If the version  is not specified, any active function versions will handle the request. If  the version is specified in the URI, then the request is exclusively processed  by the designated version of the function. By default, this endpoint will block  for 5 seconds. If the request is not fulfilled before the timeout, it's status  is considered in-progress or pending and the response includes HTTP status code  202 with an invocation request ID, indicating that the client should commence  polling for the result using the invocation request ID. Access to this endpoint  mandates inclusion of a bearer token with 'invoke_function' scope in the  HTTP Authorization header. Additionally, this endpoint has the capability to  provide updates on the progress of the request, contingent upon the workload's  provision of such information. In-progress responses are returned in order. If no in-progress response is received  during polling you will receive the most recent in-progress response. Only the first  256 unread in-progress messages are kept. ","operationId":"invokeFunction_1","parameters":[{"name":"NVCF-INPUT-ASSET-REFERENCES","in":"header","required":false,"schema":{"type":"array","items":{"type":"string"},"maxItems":2147483647,"minItems":0}},{"name":"NVCF-POLL-SECONDS","in":"header","required":false,"schema":{"type":"integer","format":"int32","maximum":300,"minimum":0}},{"name":"functionId","in":"path","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"versionId","in":"path","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"type":"object"}}},"required":true},"responses":{"200":{"description":"Invocation is fulfilled","headers":{"NVCF-REQID":{"description":"Invocation Request Id","style":"simple","schema":{"type":"string"}},"NVCF-PERCENT-COMPLETE":{"description":"Percentage complete","style":"simple","schema":{"type":"string"}},"NVCF-STATUS":{"description":"Invocation status","style":"simple","schema":{"type":"string"}}},"content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"202":{"description":"Result is pending. Client should poll using the requestId.","headers":{"NVCF-REQID":{"description":"Invocation Request Id","style":"simple","schema":{"type":"string"}},"NVCF-PERCENT-COMPLETE":{"description":"Percentage complete","style":"simple","schema":{"type":"string"}},"NVCF-STATUS":{"description":"Invocation status","style":"simple","schema":{"type":"string"}}},"content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"302":{"description":"Client should use the URL specified in the 'Location' response header to fetch\n large result.\n","headers":{"NVCF-REQID":{"description":"Invocation Request Id","style":"simple","schema":{"type":"string"}},"NVCF-PERCENT-COMPLETE":{"description":"Percentage complete","style":"simple","schema":{"type":"string"}},"NVCF-STATUS":{"description":"Invocation status","style":"simple","schema":{"type":"string"}},"Location":{"description":"URL to get the result","style":"simple","schema":{"type":"string"}}}},"402":{"description":"Cloud credits expired for public functions. Please contact NVIDIA representatives.","content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"403":{"description":"Either missing scope in the auth(SSA JWT / SAK) token and/or missing resource entry\n in the SAK for the function.\n","content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"429":{"description":"Client is doing too many requests per second and should slow down request rate.","content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}}},"deprecated":true}},"/v2/nvcf/functions":{"get":{"tags":["Function Management"],"summary":"List Functions","description":"Lists all the functions associated with the authenticated NVIDIA Cloud Account.  Requires a bearer token  with 'list_functions' or 'list_functions_details'  scope in the HTTP Authorization header.","operationId":"getFunctions","parameters":[{"name":"visibility","in":"query","description":"Query param 'visibility' indicates the kind of functions to be included\n in the response.\n","required":false,"schema":{"type":"array","default":["authorized","private","public"],"items":{"type":"string","enum":["authorized","private","public"]},"maxItems":2147483647,"minItems":0,"uniqueItems":true}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ListFunctionsResponse"}}}}}},"post":{"tags":["Function Management"],"summary":"Create Function","description":"Creates a new function within the authenticated NVIDIA Cloud Account. Requires a  bearer token with 'register_function' scope in the HTTP Authorization header. ","operationId":"createFunction","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateFunctionRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateFunctionResponse"}}}}}}},"/v2/nvcf/functions/{functionId}/versions":{"get":{"tags":["Function Management"],"summary":"List Function Versions","description":"Lists details of all the versions of the specified function in the authenticated  NVIDIA Cloud Account. Requires a bearer token  with 'list_functions' or  'list_functions_details' scopes in the HTTP Authorization header. ","operationId":"getFunctions_1","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ListFunctionsResponse"}}}}}},"post":{"tags":["Function Management"],"summary":"Create Function Version","description":"Creates a version of the specified function within the authenticated NVIDIA  Cloud Account. If the function is public, then Account Admin cannot create  a version. Requires a bearer token with 'register_function' scope in the  HTTP Authorization header. ","operationId":"createFunction_1","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateFunctionRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateFunctionResponse"}}}}}}},"/v2/nvcf/authorizations/functions/{functionId}":{"get":{"tags":["Function Sharing"],"summary":"List Account Authorizations For Function","description":"Lists NVIDIA Cloud Account IDs that are authorized to invoke any version of the  specified function. The response includes an array showing authorized accounts  for each version. Individual versions of a function can have their own  authorized accounts. So, each object in the array can have different  authorized accounts listed. Access to this functionality mandates the inclusion of a bearer token with the  'authorize_clients' scope in the HTTP Authorization header ","operationId":"getAuthorizedPartiesForAllVersions","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ListAuthorizedPartiesResponse"}}}}}},"post":{"tags":["Function Sharing"],"summary":"Authorize Accounts To Invoke Function","description":"Authorizes additional NVIDIA Cloud Accounts to invoke any version of the  specified function. By default, a function belongs to the NVIDIA Cloud Account  that created it, and the credentials used for function invocation must  reference the same NVIDIA Cloud Account. Upon invocation of this endpoint, any  existing authorized accounts will be overwritten by the newly specified  authorized accounts. Access to this functionality mandates the inclusion of a bearer token with the  'authorize_clients' scope in the HTTP Authorization header ","operationId":"createAuthorizedPartiesForAllVersions","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesResponse"}}}}}},"delete":{"tags":["Function Sharing"],"summary":"Delete All Authorizations At Function Level","description":"Deletes authorizations at the function level. This impacts all versions of  the function. If a function versions has its own set of authorizations,  those are not deleted. If the specified function is public, then  Account Admin cannot perform this operation. Note that the response does  not include any authz accounts at version level. Access to this functionality mandates the inclusion of a bearer token with the  'authorize_clients' scope in the HTTP Authorization header ","operationId":"deleteAuthorizedPartiesForAllVersions","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesResponse"}}}}}}},"/v2/nvcf/authorizations/functions/{functionId}/versions/{functionVersionId}":{"get":{"tags":["Function Sharing"],"summary":"Get Account Authorizations For Function Version","description":"Gets NVIDIA Cloud Account IDs that are authorized to invoke specified function  version. Response includes authorized accounts that were added specifically  at the version level and the authorized accounts that were inherited from  function level. Access to this functionality mandates the inclusion of a bearer token with the  'authorize_clients' scope in the HTTP Authorization header ","operationId":"getAuthorizedPartiesForSpecificVersion","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Function version","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesResponse"}}}}}},"post":{"tags":["Function Sharing"],"summary":"Authorize Accounts To Invoke/List Function Version","description":"Authorizes additional NVIDIA Cloud Accounts to invoke a specific function  version. By default, a function belongs to the NVIDIA Cloud Account that  created it, and the credentials used for function invocation must reference  the same NVIDIA Cloud Account. Upon invocation of this endpoint, any existing  authorized accounts will be overwritten by the newly specified authorized  accounts. Note that the response does NOT include inherited authorized accounts  that were added at the function level. Access to this functionality mandates the inclusion of a bearer token with the  'authorize_clients' scope in the HTTP Authorization header ","operationId":"createAuthorizedPartiesForSpecificVersion","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Function version id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesResponse"}}}}}},"delete":{"tags":["Function Sharing"],"summary":"Delete All Authorizations At Version Level","description":"Deletes all the authorized accounts that are directly associated with the  specified function version. Authorized parties that are inherited by the  function version are not deleted. If the specified function version is public,  then Account Admin cannot perform this operation. Note that the response  does not include inherited authorized accounts that were added at the function  level. Access to this functionality mandates the inclusion of a bearer token with the  'authorize_clients' scope in the HTTP Authorization header ","operationId":"deleteAuthorizedPartiesForSpecificVersion","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Function version","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesResponse"}}}}}}},"/v2/nvcf/assets":{"get":{"tags":["Asset Management"],"summary":"List Assets","description":"List assets owned by the current NVIDIA Cloud Account. Requires a  bearer token with 'invoke_function' scope in the HTTP Authorization header. ","operationId":"getAssets","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ListAssetsResponse"}}}}},"deprecated":true},"post":{"tags":["Asset Management"],"summary":"Create Asset","description":"Creates a unique id representing an asset and a pre-signed URL to upload the  asset artifact to AWS S3 bucket for the NVIDIA Cloud Account. Requires a  bearer token  with 'invoke_function' scope in the HTTP Authorization header. ","operationId":"createAsset","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateAssetRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateAssetResponse"}}}}},"deprecated":true}},"/v2/nvcf/registry-credentials/{registryCredentialId}":{"get":{"tags":["Registry Credential Management"],"summary":"Get Registry Credential Details","description":"Retrieves detailed information of the specified registry credential  associated with the authenticated NVIDIA Cloud Account. Requires a bearer token in the HTTP Authorization header with 'manage_registries' scope. ","operationId":"getRegistryCredentialDetails","parameters":[{"name":"registryCredentialId","in":"path","description":"Registry Credential id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RegistryCredentialDetailsResponse"}}}}}},"delete":{"tags":["Registry Credential Management"],"summary":"Delete Registry Credential","description":"Deletes the specified registry credential associated with the authenticated  NVIDIA Cloud Account. Requires a bearer token in the HTTP Authorization header with 'manage_registries' scope. ","operationId":"deleteRegistryCredential","parameters":[{"name":"registryCredentialId","in":"path","description":"Registry Credential id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"204":{"description":"No Content"}}},"patch":{"tags":["Registry Credential Management"],"summary":"Update registry credential","description":"Updates the secret and/or the artifact types associated with the specified  registry credential. Artifact types specified in the request body are  added to the set of artifact types that already exist for the specified  registry credential. Requires a bearer token in the HTTP Authorization header with 'manage_registries' scope. ","operationId":"updateRegistryCredential","parameters":[{"name":"registryCredentialId","in":"path","description":"Registry Credential id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateRegistryCredentialRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RegistryCredentialDetailsResponse"}}}}}}},"/v2/nvcf/deployments/{deploymentId}/gpu-specifications/{gpuSpecId}":{"patch":{"tags":["Function Deployment"],"summary":"Update the specified GPU specification under the specified deployment","description":" Updates the GPU specification of the specified function version's deployment.  It's important to note that GPU type and backend configurations cannot be  modified through this endpoint. If the specified function is public,  then Account Admin cannot perform this operation. Access to this endpoint mandates a bearer token with 'deploy_function' scope in the  HTTP Authorization header. ","operationId":"updateGpuSpecification","parameters":[{"name":"deploymentId","in":"path","description":"Deployment id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"gpuSpecId","in":"path","description":"GPU Specification id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateGpuSpecificationRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateGpuSpecificationResponse"}}}}}}},"/v2/nvcf/authorizations/functions/{functionId}/versions/{functionVersionId}/remove":{"patch":{"tags":["Function Sharing"],"summary":"Unauthorize Account From Invoking, Listing, and Checking Queue Details of Function Version","description":"Removes the specified NVIDIA Cloud Account from the set of authorized accounts  that are directly associated with specified function version. If the specified  function version does not have any of its own(not inherited) authorized  accounts, it results in a response with status 404. Also, if the specified  authorized account is not in the set of existing authorized parties that are  directly associated with the specified function version, it results in a  response with status code 404. If the specified function version is public,  then Account Admin cannot perform this operation. Note that the response  does not include inherited authorized accounts that were added at the function  level. Access to this functionality mandates the inclusion of a bearer token with the  'authorize_clients' scope in the HTTP Authorization header ","operationId":"removeAuthorizedPartyForSpecificVersion","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Function version","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchAuthorizedPartyRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesResponse"}}}}}}},"/v2/nvcf/authorizations/functions/{functionId}/versions/{functionVersionId}/add":{"patch":{"tags":["Function Sharing"],"summary":"Authorize Another Account To Invoke, List, and Check Queue Details of Function Version","description":"Adds the specified NVIDIA Cloud Account to the set of authorized accounts that  can invoke the specified function version. If the specified function version  does not have any existing inheritable authorized accounts, it results in a  response with status 404. If the specified account is already in the set of  existing authorized accounts that are directly associated with the function  version, it results in a response wit status code 409. If a function is public,  then Account Admin cannot perform this operation. Note that the response  does not include inherited authorized accounts that were added at the function  level. Access to this functionality mandates the inclusion of a bearer token with the  'authorize_clients' scope in the HTTP Authorization header ","operationId":"addAuthorizedPartyForSpecificVersion","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Function version","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchAuthorizedPartyRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesResponse"}}}}}}},"/v2/nvcf/authorizations/functions/{functionId}/remove":{"patch":{"tags":["Function Sharing"],"summary":"Unauthorize Account From Invoking, Listing, and Checking Queue Details of Function","description":"Removes the specified NVIDIA Cloud Account from the set of authorized accounts  that can invoke all the versions of the specified function. If the specified  function does not have any existing inheritable authorized parties, it results  in a response with status 404. Also, if the specified account is not in the  existing set of inheritable authorized accounts, it results in a response with  status 404. If the specified function is public, then Account Admin cannot  perform this operation. Note that response only includes the remaining  authorized accounts at the function level. Access to this functionality mandates the inclusion of a bearer token with the  'authorize_clients' scope in the HTTP Authorization header ","operationId":"removeAuthorizedPartyForAllVersions","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchAuthorizedPartyRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesResponse"}}}}}}},"/v2/nvcf/authorizations/functions/{functionId}/add":{"patch":{"tags":["Function Sharing"],"summary":"Authorize Another Account To Invoke, List, and Check Queue Details of Function","description":"Adds the specified NVIDIA Cloud Account to the set of authorized accounts that  are can invoke all the versions of the specified function. If the specified  function does not have any existing inheritable authorized accounts, it results  in a response with status 404. If the specified account is already in the set  of existing inheritable authorized accounts, it results in a response with  status code 409. If a function is public, then Account Admin cannot perform  this operation. Note that response only includes authz accounts at the  function level. Access to this functionality mandates the inclusion of a bearer token with the  'authorize_clients' scope in the HTTP Authorization header ","operationId":"addAuthorizedPartyForAllVersions","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchAuthorizedPartyRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthorizedPartiesResponse"}}}}}}},"/v2/nvcf/telemetries/{telemetryId}":{"get":{"tags":["Telemetry Management"],"summary":"Get Telemetry Details","description":"Retrieves the details of a specific telemetry configuration by its ID.  requires a bearer token with 'manage_telemetries' scope in the HTTP  Authorization header. ","operationId":"getTelemetry","parameters":[{"name":"telemetryId","in":"path","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TelemetryResponse"}}}}}},"delete":{"tags":["Telemetry Management"],"summary":"Delete Telemetry","description":"Deletes a specific telemetry configuration for a NVIDIA Cloud Account.  requires a bearer token with 'manage_telemetries' scope in the HTTP  Authorization header. If there any functions that are dependent on the  Telemetry that is being deleted, then response with 400 status code will  be returned. ","operationId":"deleteTelemetry","parameters":[{"name":"telemetryId","in":"path","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"204":{"description":"No Content"},"400":{"description":"Cannot be deleted till Functions depend on it"}}}},"/v2/nvcf/recognized-registries":{"get":{"tags":["Registry Credential Management"],"summary":"List Recognized Registries","description":"Lists all the registries that are recognized by NVCF. Only when a registry  is recognized by NVCF that the users can add its credential to their account  and then use it to create functions. Requires a bearer token in the HTTP Authorization header with 'manage_registries' scope. ","operationId":"getRecognizedRegistries","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RecognizedRegistriesResponse"}}}}}}},"/v2/nvcf/queues/{requestId}/position":{"get":{"tags":["Queue Details"],"summary":"Queue Position","description":"Using the specified function invocation request id, returns the estimated  position of the corresponding message up to 1000 in the queue. Requires a bearer token or an api-key with 'queue_details' scope in the HTTP  Authorization header. ","operationId":"getPositionInQueue","parameters":[{"name":"requestId","in":"path","description":"Function invocation request id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetPositionInQueueResponse"}}}}}}},"/v2/nvcf/queues/functions/{functionId}/versions/{versionId}":{"get":{"tags":["Queue Details"],"summary":"Queue Details","description":"Provides details of all the queues associated with the specified function.  If a function has multiple versions and they are all deployed, then the  response includes details of all the queues. If the specified function  is public, then Account Admin cannot perform this operation. Requires a bearer token or an api-key with 'queue_details' scope in the HTTP  Authorization header. ","operationId":"getQueuesDetails","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"versionId","in":"path","description":"Function version id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetQueuesResponse"}}}}}}},"/v2/nvcf/queues/functions/{functionId}":{"get":{"tags":["Queue Details"],"summary":"Queue Details","description":"Provides details of all the queues associated with the specified function.  If a function has multiple versions and they are all deployed, then the  response includes details of all the queues. If the specified function  is public, then Account Admin cannot perform this operation. Requires a bearer token or an api-key with 'queue_details' scope in the HTTP  Authorization header. ","operationId":"getQueuesDetails_1","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetQueuesResponse"}}}}}}},"/v2/nvcf/pexec/status/{requestId}":{"get":{"tags":["Function Invocation"],"summary":"Poll For Result Using Function Invocation Request","description":"Deprecated and will be removed soon. Please use the new NVCF Invocation API  endpoint to invoke a function and stream results without polling.  Retrieves the status of an in-progress or pending request using its unique  invocation request ID. If the result is available, it will be included in  the response, marking the request as fulfilled. Conversely, if the result is  not yet available, the request is deemed pending. Access to this endpoint  mandates inclusion of a bearer token with 'invoke_function' scope in the  HTTP Authorization header. In-progress responses are returned in order. If no in-progress response is received  during polling you will receive the most recent in-progress response. Only the first  256 unread in-progress messages are kept. ","operationId":"getFunctionInvocationResult","parameters":[{"name":"requestId","in":"path","description":"Invocation Request Id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"Invocation is fulfilled","headers":{"NVCF-REQID":{"description":"Invocation Request Id","style":"simple","schema":{"type":"string"}},"NVCF-PERCENT-COMPLETE":{"description":"Percentage complete","style":"simple","schema":{"type":"string"}},"NVCF-STATUS":{"description":"Invocation status","style":"simple","schema":{"type":"string"}}},"content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"202":{"description":"Result is pending. Client should poll using the requestId.","headers":{"NVCF-REQID":{"description":"Invocation Request Id","style":"simple","schema":{"type":"string"}},"NVCF-PERCENT-COMPLETE":{"description":"Percentage complete","style":"simple","schema":{"type":"string"}},"NVCF-STATUS":{"description":"Invocation status","style":"simple","schema":{"type":"string"}}},"content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"302":{"description":"Client should use the URL specified in the 'Location' response header to fetch\n large result.\n","headers":{"NVCF-REQID":{"description":"Invocation Request Id","style":"simple","schema":{"type":"string"}},"NVCF-PERCENT-COMPLETE":{"description":"Percentage complete","style":"simple","schema":{"type":"string"}},"NVCF-STATUS":{"description":"Invocation status","style":"simple","schema":{"type":"string"}},"Location":{"description":"URL to get the result","style":"simple","schema":{"type":"string"}}}},"402":{"description":"Cloud credits expired for public functions. Please contact NVIDIA representatives.","content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}},"403":{"description":"Either missing scope in the auth(SSA JWT / SAK) token and/or missing resource entry\n in the SAK for the function.\n","content":{"*/*":{"schema":{"type":"object","properties":{"short":{"type":"integer","format":"int32"},"char":{"type":"string"},"int":{"type":"integer","format":"int32"},"long":{"type":"integer","format":"int64"},"float":{"type":"number","format":"float"},"double":{"type":"number","format":"double"},"direct":{"type":"boolean"},"readOnly":{"type":"boolean"}}}}}}},"deprecated":true}},"/v2/nvcf/functions/{functionId}/versions/{functionVersionId}":{"get":{"tags":["Function Management"],"summary":"Get Function Version Details","description":"Retrieves detailed information of the specified function version in the  authenticated NVIDIA Cloud Account. Requires a bearer token with  'list_functions' or 'list_functions_details' scopes in the HTTP  Authorization header. ","operationId":"getFunction","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Version id ","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"includeSecrets","in":"query","description":"Query param 'includeSecrets' indicates whether to include secret names\n for the function in the response.\n","required":false,"schema":{"type":"boolean","default":true}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/FunctionResponse"}}}}}},"delete":{"tags":["Function Management"],"summary":"Delete Function","description":"Deletes the specified function version in the authenticated NVIDIA Cloud  Account. Requires a bearer token with 'delete_function' scope in the HTTP  Authorization header. If the function version is public, then Account Admin  cannot delete the function. ","operationId":"deleteFunction","parameters":[{"name":"functionId","in":"path","description":"Function id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}},{"name":"functionVersionId","in":"path","description":"Version id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"204":{"description":"No Content"}}}},"/v2/nvcf/functions/ids":{"get":{"tags":["Function Management"],"summary":"List Function Ids","description":"Lists ids of all the functions in the authenticated NVIDIA Cloud Account.  Requires a bearer token with 'list_functions' or 'list_functions_details'  scopes in the HTTP Authorization header. ","operationId":"getFunctionIds","parameters":[{"name":"visibility","in":"query","description":"Query param 'visibility' indicates the kind of functions to be included\n in the response.\n","required":false,"schema":{"type":"array","default":["authorized","private","public"],"items":{"type":"string","enum":["authorized","private","public"]},"maxItems":2147483647,"minItems":0,"uniqueItems":true}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ListFunctionIdsResponse"}}}}}}},"/v2/nvcf/deployments/{deploymentId}":{"get":{"tags":["Function Deployment"],"summary":"Get Function Deployment Details","description":"Allows Account Admins to retrieve the deployment details of the specified  deployment id. Access to this endpoint mandates a bearer token with 'deploy_function' scope in the  HTTP Authorization header. ","operationId":"getFunctionDeployment_1","parameters":[{"name":"deploymentId","in":"path","description":"Deployment id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentResponse"}}}}}}},"/v2/nvcf/clusterGroups":{"get":{"tags":["Cluster Groups and GPUs"],"summary":"List Cluster Groups","description":"Lists Cluster Groups for the current account. The response includes cluster  groups defined specifically in the current account and publicly available  cluster groups such as GFN, OCI, etc. Requires a bearer token with 'list_cluster_groups' scope in HTTP Authorization header. ","operationId":"getClusterGroups","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClusterGroupsResponse"}}}}},"deprecated":true,"security":[{"ssa":["list_cluster_groups"]}]}},"/v2/nvcf/assets/{assetId}":{"get":{"tags":["Asset Management"],"summary":"Show Asset Details","description":"Returns details for the specified asset-id belonging to the current NVIDIA  Cloud Account. Requires a bearer token with 'invoke_function' scope in  the HTTP Authorization header. ","operationId":"getAsset","parameters":[{"name":"assetId","in":"path","description":"Asset id","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AssetResponse"}}}}},"deprecated":true},"delete":{"tags":["Asset Management"],"summary":"Delete Asset","description":"Deletes asset belonging to the current NVIDIA Cloud Account. Requires  a bearer token with 'invoke_function' scope in the HTTP Authorization header. ","operationId":"deleteAsset","parameters":[{"name":"assetId","in":"path","description":"Id of the asset to be deleted","required":true,"schema":{"type":"string","format":"uuid","maxLength":36,"minLength":36}}],"responses":{"204":{"description":"No Content"}},"deprecated":true}},"/health/**":{"get":{"tags":["Health"],"summary":"Get Health Information","description":"Get Health Information about this service","operationId":"getHealth","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HealthComponent"}}}}}}}},"components":{"schemas":{"JsonNode":{},"SecretDto":{"type":"object","description":"Data Transfer Object(DTO) representing secret name/value pair","properties":{"name":{"type":"string","description":"Secret name","maxLength":48,"minLength":1,"pattern":"^[a-z0-9A-Z][a-z0-9A-Z\\_\\.\\-]*$"},"value":{"$ref":"#/components/schemas/JsonNode","description":"Secret value must be 1 - 32768 chars long"}},"required":["name"]},"UpdateTelemetrySecretRequest":{"type":"object","description":"Request payload to update secret","properties":{"secret":{"$ref":"#/components/schemas/SecretDto","description":"Telemetry secret"}},"required":["secret"]},"UpdateFunctionSecretsRequest":{"type":"object","description":"Request payload to update secrets","properties":{"secrets":{"type":"array","description":"Secrets","items":{"$ref":"#/components/schemas/SecretDto"},"uniqueItems":true}},"required":["secrets"]},"RateLimitDto":{"type":"object","description":"Data Transfer Object(DTO) representing Rate limit config","properties":{"rateLimit":{"type":"string","description":"Rate","pattern":"^(?!.*-([SMHD]).*-\\1)[1-9]\\d*-[SMHD](,\\s*[1-9]\\d*-[SMHD])*$"},"exemptedNcaIds":{"type":"array","description":"NCA ID Exemptions","items":{"type":"string"},"maxItems":32,"minItems":0,"uniqueItems":true},"perNcaIdRate":{"type":"object","additionalProperties":{"type":"string"},"description":"Per NCA ID Rate"},"syncCheck":{"type":"boolean","description":"Sync check. Defaults to false"}}},"UpdateRatelimitRequest":{"type":"object","description":"Request payload to update ratelimit policy","properties":{"rateLimit":{"$ref":"#/components/schemas/RateLimitDto","description":"Ratelimit policy"}},"required":["rateLimit"]},"UpdateFunctionMetadataRequest":{"type":"object","description":"Request payload to create tags.","properties":{"tags":{"type":"array","description":"Set of tags provided by user","items":{"type":"string","pattern":"[a-zA-Z0-9\\-_:=]+"},"maxItems":64,"minItems":0,"uniqueItems":true}}},"ArtifactDto":{"type":"object","description":"Data Transfer Object(DTO) representing an artifact","properties":{"name":{"type":"string","description":"Artifact name"},"version":{"type":"string","description":"Artifact version"},"uri":{"type":"string","format":"uri","description":"Artifact URI"}},"required":["name","uri","version"]},"ContainerEnvironmentEntryDto":{"type":"object","description":"Data Transfer Object(DTO) representing a container environment entry","properties":{"key":{"type":"string","description":"Container environment key"},"value":{"type":"string","description":"Container environment value"}},"required":["key","value"]},"FunctionDto":{"type":"object","description":"Data Transfer Object (DTO) representing a function","properties":{"id":{"type":"string","format":"uuid","description":"Unique function id"},"ncaId":{"type":"string","description":"NVIDIA Cloud Account Id"},"versionId":{"type":"string","format":"uuid","description":"Unique function version id"},"name":{"type":"string","description":"Function name"},"status":{"type":"string","description":"Function status","enum":["ACTIVE","DEPLOYING","ERROR","INACTIVE","DELETED","DEGRADED","DEGRADING"]},"inferenceUrl":{"type":"string","format":"uri","description":"Entrypoint for invoking the container to process requests"},"ownedByDifferentAccount":{"type":"boolean","description":"Indicates whether the function is owned by another account. If the account\n that is being used to lookup functions happens to be authorized to invoke/list\n this function which is owned by a different account, then this field is set\n to true and ncaId will contain the id of the account that owns the function.\n Otherwise, this field is not set as it defaults to false.\n"},"inferencePort":{"type":"integer","format":"int32","description":"Optional port number where the inference listener is running - defaults to 8000 for Triton"},"containerArgs":{"type":"string","description":"Args used to launch the container"},"containerEnvironment":{"type":"array","description":"Environment settings used to launch the container","items":{"$ref":"#/components/schemas/ContainerEnvironmentEntryDto"}},"models":{"type":"array","description":"Optional set of models","items":{"$ref":"#/components/schemas/ArtifactDto"},"uniqueItems":true},"containerImage":{"type":"string","format":"uri","description":"Optional custom container"},"apiBodyFormat":{"type":"string","description":"Invocation request body format","enum":["PREDICT_V2","CUSTOM"]},"helmChart":{"type":"string","format":"uri","description":"Optional Helm Chart"},"helmChartServiceName":{"type":"string","description":"Helm Chart Service Name specified only when helmChart property is specified\n"},"healthUri":{"type":"string","format":"uri","deprecated":true,"description":"Health endpoint for the container or helmChart. Deprecated, use health.uri instead."},"createdAt":{"type":"string","format":"date-time","description":"Function creation timestamp"},"activeInstances":{"type":"array","description":"List of active instances for this function.","items":{"$ref":"#/components/schemas/InstanceDto"}},"resources":{"type":"array","description":"Optional set of resources.","items":{"$ref":"#/components/schemas/ArtifactDto"},"uniqueItems":true},"tags":{"type":"array","description":"Optional set of tags. Maximum allowed number of tags per function is 64. Maximum length of each tag is 128 chars.","items":{"type":"string"},"uniqueItems":true},"description":{"type":"string","description":"Function/version description"},"health":{"$ref":"#/components/schemas/HealthDto","description":"Function health configuration"},"functionType":{"type":"string","description":"Used to indicate a STREAMING function. Defaults to DEFAULT.","enum":["DEFAULT","STREAMING"]},"secrets":{"type":"array","description":"Optional secret names","items":{"type":"string"},"uniqueItems":true},"rateLimit":{"$ref":"#/components/schemas/RateLimitDto","description":"Optional rate limit policy"},"telemetries":{"$ref":"#/components/schemas/TelemetriesDto","description":"Optional telemetry configuration for the function"}},"required":["createdAt","functionType","healthUri","id","name","ncaId","status","versionId"]},"FunctionResponse":{"type":"object","description":"Response body with function details","properties":{"function":{"$ref":"#/components/schemas/FunctionDto","description":"Function details"}},"required":["function"]},"HealthDto":{"type":"object","description":"Data Transfer Object(DTO) representing a function ne","properties":{"protocol":{"type":"string","description":"HTTP/gPRC protocol type for health endpoint","enum":["HTTP","gRPC"]},"uri":{"type":"string","format":"uri","description":"Health endpoint for the container or the helmChart"},"port":{"type":"integer","format":"int32","description":"Port number where the health listener is running"},"timeout":{"type":"string","format":"duration","description":"ISO 8601 duration string in PnDTnHnMn.nS format","example":"PT10S"},"expectedStatusCode":{"type":"integer","format":"int32","description":"Expected return status code considered as successful."}},"required":["expectedStatusCode","port","protocol","timeout","uri"]},"InstanceDto":{"type":"object","description":"Data Transfer Object(DTO) representing a spot instance","properties":{"instanceId":{"type":"string","description":"Unique id of the instance"},"functionId":{"type":"string","format":"uuid","description":"Function executing on the instance"},"functionVersionId":{"type":"string","format":"uuid","description":"Function version executing on the instance"},"instanceType":{"type":"string","description":"GPU instance-type powering the instance"},"instanceStatus":{"type":"string","description":"Instance status","enum":["ACTIVE","STARTING","RUNNING","ERRORED","PREEMPTED","DELETED","TERMINATED"]},"sisRequestId":{"type":"string","format":"uuid","description":"SIS request-id used to launch this instance"},"ncaId":{"type":"string","description":"NVIDIA Cloud Account Id that owns the function running on the instance"},"gpu":{"type":"string","description":"GPU name powering the instance"},"backend":{"type":"string","description":"Backend where the instance is running"},"location":{"type":"string","description":"Location such as zone name or region where the instance is running"},"instanceCreatedAt":{"type":"string","format":"date-time","description":"Instance creation timestamp"},"instanceUpdatedAt":{"type":"string","format":"date-time","description":"Instance's last updated timestamp"}}},"TelemetriesDto":{"type":"object","description":"Telemetry configuration for logs, metrics, and traces.","properties":{"logsTelemetryId":{"type":"string","format":"uuid","description":"UUID representing the logs telemetry."},"metricsTelemetryId":{"type":"string","format":"uuid","description":"UUID representing the metrics telemetry."},"tracesTelemetryId":{"type":"string","format":"uuid","description":"UUID representing the traces telemetry."}}},"UpdateFunctionDeploymentRequest":{"type":"object","description":"Request to update function deployment spec","properties":{"deploymentSpecifications":{"type":"array","description":"Deployment specs with GPU, instance-type, etc. details for update request","items":{"$ref":"#/components/schemas/UpdateGpuSpecificationDto"},"minItems":1}},"required":["deploymentSpecifications"]},"UpdateGpuSpecificationDto":{"type":"object","description":"Data Transfer Object (DTO) representing GPU specification for Deployment Update case.","properties":{"gpuSpecificationId":{"type":"string","format":"uuid","description":"GPU specification id"},"gpu":{"type":"string","description":"GPU name from the cluster. Deprecated: this is read-only field, should not be specified in update request."},"backend":{"type":"string","description":"Backend/CSP where the GPU powered instance has been launched. The original value\nwould not be updated and it should be the same as original. The field is required\nonly for validation.\n"},"clusters":{"type":"array","description":"Specific clusters within spot instance or worker node powered by the selected\ninstance-type to deploy function. The original value would not be updated and it\nshould be the same as original. The field is required only for validation.\n","items":{"type":"string"},"uniqueItems":true},"maxInstances":{"type":"integer","format":"int32","description":"Maximum number of spot instances for the deployment"},"minInstances":{"type":"integer","format":"int32","description":"Minimum number of spot instances for the deployment"},"instanceType":{"type":"string","description":"Instance type, based on GPU, assigned to a Worker. Deprecated: this is read-only field, should not be specified in update request."},"maxRequestConcurrency":{"type":"integer","format":"int32","description":"Max request concurrency between 1 (default) and 16384.","maximum":16384,"minimum":1}},"required":["maxInstances","minInstances"]},"AutoscalingConfigurationDto":{"type":"object","description":"Data Transfer Object(DTO) representing autoscaling configuration","properties":{"scaleUpDetails":{"$ref":"#/components/schemas/ScalingDetails","description":"Configuration for scaling up"},"scaleDownDetails":{"$ref":"#/components/schemas/ScalingDetails","description":"Configuration for scaling down"}}},"DeploymentHealthDto":{"type":"object","description":"Data Transfer Object(DTO) representing deployment error","properties":{"sisRequestId":{"type":"string","format":"uuid","description":"SIS Request ID"},"gpu":{"type":"string","description":"GPU Type as per SDD","minLength":1},"backend":{"type":"string","description":"Backend/CSP where the GPU powered instance will be launched","minLength":1},"instanceType":{"type":"string","description":"Instance type"},"error":{"type":"string","description":"Deployment error","minLength":1}},"required":["backend","error","gpu","sisRequestId"]},"DeploymentResponse":{"type":"object","description":"Function Deployment Response","properties":{"deployment":{"$ref":"#/components/schemas/FunctionDeploymentDto","description":"Deployment details"}},"required":["deployment"]},"FunctionDeploymentDto":{"type":"object","description":"Function deployment response","properties":{"functionId":{"type":"string","format":"uuid","description":"Function id"},"functionVersionId":{"type":"string","format":"uuid","description":"Function version id"},"deploymentId":{"type":"string","format":"uuid","description":"Last deployment id"},"functionName":{"type":"string","description":"Function name","minLength":1},"ncaId":{"type":"string","description":"NVIDIA Cloud Account Id","minLength":1},"functionStatus":{"type":"string","description":"Function status","enum":["ACTIVE","DEPLOYING","ERROR","INACTIVE","DELETED","DEGRADED","DEGRADING"]},"healthInfo":{"type":"array","description":"Health info for a deployment specification is included only if there are any\n issues/errors.\n","items":{"$ref":"#/components/schemas/DeploymentHealthDto"}},"deploymentSpecifications":{"type":"array","description":"Function deployment details","items":{"$ref":"#/components/schemas/GpuSpecificationDto"}},"createdAt":{"type":"string","format":"date-time","description":"Function deployment creation timestamp"},"lastUpdatedAt":{"type":"string","format":"date-time","description":"Function deployment modification timestamp"}},"required":["createdAt","deploymentId","deploymentSpecifications","functionId","functionName","functionStatus","functionVersionId","lastUpdatedAt","ncaId"]},"GpuSpecificationDto":{"type":"object","description":"Data Transfer Object(DTO) representing GPU specification.","properties":{"gpuSpecificationId":{"type":"string","format":"uuid","description":"GPU specification id"},"gpu":{"type":"string","description":"GPU name from the cluster","minLength":1},"backend":{"type":"string","description":"Backend/CSP where the GPU powered instance will be launched"},"maxInstances":{"type":"integer","format":"int32","description":"Maximum number of spot instances for the deployment"},"minInstances":{"type":"integer","format":"int32","description":"Minimum number of spot instances for the deployment"},"instanceType":{"type":"string","description":"Instance type, based on GPU, assigned to a Worker","minLength":1},"availabilityZones":{"type":"array","description":"List of availability-zones(or clusters) in the cluster group","items":{"type":"string"}},"maxRequestConcurrency":{"type":"integer","format":"int32","description":"Max request concurrency between 1 (default) and 16384.","maximum":16384,"minimum":1},"configuration":{"type":"object","description":"Typically used when the function is based on Helm Charts to substitute\n placeholders in values yaml.\n"},"clusters":{"type":"array","description":"Specific clusters within spot instance or worker node powered by the selected\ninstance-type to deploy function.\n","items":{"type":"string"},"uniqueItems":true},"regions":{"type":"array","description":"List of regions allowed to deploy. The instance or worker node will be in one of\nthe specified geographical regions.\n","items":{"type":"string"},"uniqueItems":true},"attributes":{"type":"array","description":"Specific attributes capabilities to deploy functions.\n","items":{"type":"string"},"uniqueItems":true},"preferredOrder":{"type":"integer","format":"int32","description":"Preferred order of deployment if there are several gpu specs.","maximum":99,"minimum":1},"cpuArch":{"type":"string","description":"Architecture details of the CPU"},"os":{"type":"string","description":"Operating system details"},"driverVersion":{"type":"string","description":"GPU driver version"},"storage":{"type":"string","description":"The amount of available storage, e.g. 80G"},"systemMemory":{"type":"string","description":"The amount of RAM"},"gpuMemory":{"type":"string","description":"The amount of GPU memory"},"autoscalingConfiguration":{"$ref":"#/components/schemas/AutoscalingConfigurationDto","description":"Customizable Autoscaler configuration"}},"required":["gpu","instanceType","maxInstances","minInstances"]},"ScalingDetails":{"type":"object","properties":{"metric":{"type":"string","description":"Scaling metric"},"factor":{"type":"number","format":"float","description":"Scaling factor must be greater-than 1.0 for scale up and less-than 1.0 for scale down. This factor is used to multiply the currentinstance count when specified threshold is met."},"threshold":{"type":"integer","format":"int32","description":"Scaling threshold (0-100) as a percentage of utilizationupon which the number of current instances are multiplied with thespecified factor."},"stickiness":{"$ref":"#/components/schemas/StickinessWindow","description":"Stickiness window configuration"}},"required":["factor","threshold"]},"StickinessWindow":{"type":"object","properties":{"size":{"type":"string","format":"duration","description":"Window size must be less than or equal to PT1H and will berounded to the nearest minute","example":"PT30M"},"threshold":{"type":"string","format":"duration","description":"Window threshold must be less than size","example":"PT5M"}},"required":["size","threshold"]},"BasicFunctionDto":{"type":"object","description":"Basic Data Transfer Object (DTO) representing a function","properties":{"functionId":{"type":"string","format":"uuid","description":"Unique function id"},"functionVersionId":{"type":"string","format":"uuid","description":"Unique function version id"}},"required":["functionId"]},"MultiFunctionsInvocationTokenRequest":{"type":"object","description":"Request body for issuing a function invocation token","properties":{"functions":{"type":"array","description":"Functions to invoke","items":{"$ref":"#/components/schemas/BasicFunctionDto"},"maxItems":4,"minItems":0},"clientId":{"type":"string","description":"ClientId for client to pass in to track who will eventually use the token","minLength":1}},"required":["clientId","functions"]},"InvocationTokenResponse":{"type":"object","description":"Function invocation token response","properties":{"access_token":{"type":"string","description":"Token issued by Notary Service"},"expires_in":{"type":"integer","format":"int32","description":"Token expiration time in seconds"}}},"InvocationTokenRequest":{"type":"object","description":"Request body for issuing a function invocation token","properties":{"clientId":{"type":"string","description":"ClientId for client to pass in to track who will eventually use the token","minLength":1}},"required":["clientId"]},"TelemetryRequest":{"type":"object","description":"Data Transfer Object (DTO) representing a telemetry request","properties":{"endpoint":{"type":"string","description":"Telemetry endpoint URL","minLength":1},"protocol":{"type":"string","description":"Protocol used for communication","enum":["HTTP","GRPC"]},"provider":{"type":"string","description":"Telemetry provider","enum":["PROMETHEUS","GRAFANA_CLOUD","SPLUNK","DATADOG","SERVICENOW","KRATOS","KRATOS_THANOS","TIMESTREAM","VICTORIAMETRICS","AZURE_MONITOR","OTEL_COLLECTOR"]},"types":{"type":"array","description":"Set of telemetry data types","items":{"type":"string","enum":["LOGS","METRICS","TRACES"]},"minItems":1,"uniqueItems":true},"secret":{"$ref":"#/components/schemas/SecretDto","description":"Single secret associated with the telemetry configuration"}},"required":["endpoint","protocol","provider","secret","types"]},"TelemetryDto":{"type":"object","description":"Data Transfer Object (DTO) for Telemetry configurations","properties":{"telemetryId":{"type":"string","format":"uuid","description":"Unique telemetry ID"},"name":{"type":"string","description":"Telemetry name","minLength":1},"endpoint":{"type":"string","description":"URL for the telemetry endpoint","minLength":1},"protocol":{"type":"string","description":"Protocol used for communication","enum":["HTTP","GRPC"]},"provider":{"type":"string","description":"Telemetry provider","enum":["PROMETHEUS","GRAFANA_CLOUD","SPLUNK","DATADOG","SERVICENOW","KRATOS","KRATOS_THANOS","TIMESTREAM","VICTORIAMETRICS","AZURE_MONITOR","OTEL_COLLECTOR"]},"types":{"type":"array","description":"Set of telemetry data types","items":{"type":"string","enum":["LOGS","METRICS","TRACES"]},"minItems":1,"uniqueItems":true},"createdAt":{"type":"string","format":"date-time","description":"Telemetry creation timestamp"}},"required":["createdAt","endpoint","name","protocol","provider","telemetryId","types"]},"TelemetryResponse":{"type":"object","description":"Data Transfer Object (DTO) representing a telemetry response","properties":{"telemetry":{"$ref":"#/components/schemas/TelemetryDto","description":"Telemetry details"}}},"AddRegistryCredentialRequest":{"type":"object","description":"Request body to add a registry credential to an account","properties":{"registryHostname":{"type":"string","description":"Registry hostname","maxLength":255,"minLength":1,"pattern":"(?=^.{4,253}$)(^((?!-)[a-zA-Z0-9-]{1,63}(?<!-)\\.)+[a-zA-Z0-9]{2,63}$)"},"secret":{"$ref":"#/components/schemas/SecretDto","description":"Registry credential - secret value must be base64 encoded string in username:password format"},"artifactTypes":{"type":"array","description":"Artifact types that can be retrieved using this credential","items":{"type":"string","enum":["CONTAINER","HELM","MODEL","RESOURCE"]},"minItems":1,"uniqueItems":true},"tags":{"type":"array","description":"Optional set of tags","items":{"type":"string","pattern":"[a-zA-Z0-9\\-_:=]+"},"maxItems":64,"minItems":0,"uniqueItems":true},"description":{"type":"string","description":"Optional registry credential description"}},"required":["artifactTypes","registryHostname","secret"]},"RegistryCredentialDetailsDto":{"type":"object","description":"DTO representing a registry credential","properties":{"registryCredentialId":{"type":"string","format":"uuid","description":"Registry Credential Id"},"ncaId":{"type":"string","description":"NVIDIA Cloud Account Id owning the Registry Credential","minLength":1},"registryCredentialName":{"type":"string","description":"Registry Credential name","minLength":1},"registryName":{"type":"string","description":"Recognized registry name","minLength":1},"registryHostname":{"type":"string","description":"Registry hostname","minLength":1},"artifactTypes":{"type":"array","description":"Registry type","items":{"type":"string","enum":["CONTAINER","HELM","MODEL","RESOURCE"]},"minItems":1,"uniqueItems":true},"tags":{"type":"array","description":"Optional set of tags","items":{"type":"string"},"uniqueItems":true},"description":{"type":"string","description":"Registry credential description"},"provisionedBy":{"type":"string","description":"Registry credential provisioned by system or user","enum":["SYSTEM","USER"]},"lastUpdatedAt":{"type":"string","format":"date-time","description":"Timestamp for last registry credential update"},"createdAt":{"type":"string","format":"date-time","description":"Timestamp for registry credential creation"}},"required":["artifactTypes","createdAt","lastUpdatedAt","ncaId","provisionedBy","registryCredentialId","registryCredentialName","registryHostname","registryName"]},"RegistryCredentialDetailsResponse":{"type":"object","description":"Response body for Registry Credential operations","properties":{"registryCredential":{"$ref":"#/components/schemas/RegistryCredentialDetailsDto","description":"Registry credential details"}},"required":["registryCredential"]},"CreateFunctionRequest":{"type":"object","description":"Request payload to create function.","properties":{"name":{"type":"string","description":"Function name must start with lowercase/uppercase/digit and can only contain lowercase, uppercase, digit, hyphen, and underscore characters","maxLength":128,"minLength":1,"pattern":"^[a-z0-9A-Z][a-z0-9A-Z\\-_]*$"},"inferenceUrl":{"type":"string","format":"uri","description":"Entrypoint for invoking the container to process a request"},"healthUri":{"type":"string","format":"uri","deprecated":true,"description":"Health endpoint for the container or the helmChart"},"inferencePort":{"type":"integer","format":"int32","description":"Optional port number where the inference listener is running. Defaults to 8000\n for Triton.\n"},"health":{"$ref":"#/components/schemas/HealthDto","description":"Function health"},"containerArgs":{"type":"string","description":"Args to be passed when launching the container"},"containerEnvironment":{"type":"array","description":"Environment settings for launching the container","items":{"$ref":"#/components/schemas/ContainerEnvironmentEntryDto"}},"models":{"type":"array","description":"Optional set of models","items":{"$ref":"#/components/schemas/ArtifactDto"},"uniqueItems":true},"containerImage":{"type":"string","format":"uri","description":"Optional custom container image"},"helmChart":{"type":"string","format":"uri","description":"Optional Helm Chart"},"helmChartServiceName":{"type":"string","description":"Helm Chart Service Name is required when helmChart property is specified\n"},"resources":{"type":"array","description":"Optional set of resources","items":{"$ref":"#/components/schemas/ArtifactDto"},"uniqueItems":true},"apiBodyFormat":{"type":"string","description":"Invocation request body format","enum":["PREDICT_V2","CUSTOM"]},"tags":{"type":"array","description":"Optional set of tags - could be empty. Provided by user","items":{"type":"string","pattern":"[a-zA-Z0-9\\-_:=]+"},"maxItems":64,"minItems":0,"uniqueItems":true},"description":{"type":"string","description":"Optional function/version description"},"secrets":{"type":"array","description":"Optional secrets","items":{"$ref":"#/components/schemas/SecretDto"},"uniqueItems":true},"functionType":{"type":"string","description":"Optional function type, used to indicate a STREAMING function. Defaults to DEFAULT.","enum":["DEFAULT","STREAMING"]},"rateLimit":{"$ref":"#/components/schemas/RateLimitDto","description":"Optional rate limit config"},"telemetries":{"$ref":"#/components/schemas/TelemetriesDto","description":"Optional telemetry configuration for logs, metrics, and traces."}},"required":["inferenceUrl","name"]},"CreateFunctionResponse":{"type":"object","description":"Response body for create function request.","properties":{"function":{"$ref":"#/components/schemas/FunctionDto","description":"Details of the newly created function"}},"required":["function"]},"FunctionDeploymentRequest":{"type":"object","description":"Request to deploy a function","properties":{"deploymentSpecifications":{"type":"array","description":"GPU specs with GPU, instance-type, clusters etc. details","items":{"$ref":"#/components/schemas/GpuSpecificationDto"},"minItems":1}},"required":["deploymentSpecifications"]},"AuthorizedPartiesRequest":{"type":"object","description":"Request to associated authorized parties for a specific version or allversions of a function","properties":{"authorizedParties":{"type":"array","description":"Parties authorized to invoke function","items":{"$ref":"#/components/schemas/AuthorizedPartyDto"},"minItems":1}},"required":["authorizedParties"]},"AuthorizedPartyDto":{"type":"object","description":"Data Transfer Object(DTO) representing an authorized party.","properties":{"clientId":{"type":"string","description":"Client Id -- 'sub' claim in the JWT. This field should not be\n specified anymore."},"ncaId":{"type":"string","description":"NVIDIA Cloud Account authorized to invoke the function","minLength":1}},"required":["ncaId"]},"AuthorizedPartiesByFunctionDto":{"type":"object","description":"Data Transfer Object(DTO) representing a function with authorized accounts","properties":{"id":{"type":"string","format":"uuid","description":"Function id"},"ncaId":{"type":"string","description":"NVIDIA Cloud Account Id","minLength":1},"versionId":{"type":"string","format":"uuid","description":"Function version id"},"authorizedParties":{"type":"array","description":"Authorized parties allowed to invoke the function","items":{"$ref":"#/components/schemas/AuthorizedPartyDto"}}},"required":["id","ncaId"]},"AuthorizedPartiesResponse":{"type":"object","description":"Parties authorized to invoke function","properties":{"function":{"$ref":"#/components/schemas/AuthorizedPartiesByFunctionDto","description":"Function with authorized parties and other details"}},"required":["function"]},"CreateAssetRequest":{"type":"object","description":"Request payload to create an asset-id and the corresponding pre-signed URL to upload an asset of specified content-type to AWS S3 bucket.","properties":{"contentType":{"type":"string","description":"Content type of the asset such image/png, image/jpeg, etc."},"description":{"type":"string","description":"Asset description"}},"required":["contentType","description"]},"CreateAssetResponse":{"type":"object","description":"Response body containing asset-id and the corresponding pre-signed URL to upload an asset of specified content-type to AWS S3 bucket.","properties":{"assetId":{"type":"string","format":"uuid","description":"Unique id of the asset to be uploaded to AWS S3 bucket"},"uploadUrl":{"type":"string","format":"url","description":"Pre-signed upload URL to upload asset"},"contentType":{"type":"string","description":"Content type of the asset such image/png, image/jpeg, etc."},"description":{"type":"string","description":"Asset description to be used when uploading the asset"}}},"UpdateRegistryCredentialRequest":{"type":"object","description":"Request body to update registry credential","properties":{"secret":{"$ref":"#/components/schemas/SecretDto","description":"Registry credential - secret value must be base64 encoded string in username:password format"},"artifactTypeEnums":{"type":"array","description":"Optional artifact types to be added to the existing ones","items":{"type":"string","enum":["CONTAINER","HELM","MODEL","RESOURCE"]},"uniqueItems":true}}},"UpdateGpuSpecificationRequest":{"type":"object","description":"Request to update single function deployment GPU Specification","properties":{"maxInstances":{"type":"integer","format":"int32","description":"Maximum number of spot instances for the deployment"},"minInstances":{"type":"integer","format":"int32","description":"Minimum number of spot instances for the deployment"},"autoscalingConfiguration":{"$ref":"#/components/schemas/AutoscalingConfigurationDto","description":"Customizable Autoscaling configuration"},"autoscalingConfigurationPolicy":{"type":"string","description":"Autoscaling configuration policy. CUSTOM_CONFIGURATION (default): use the provided autoscalingConfig. PLATFORM_CONFIGURATION: remove custom config and use platform defaults.","enum":["CUSTOM_CONFIGURATION","PLATFORM_CONFIGURATION"]}}},"UpdateGpuSpecificationResponse":{"type":"object","description":"Update GPU Specification Response","properties":{"gpuSpecification":{"$ref":"#/components/schemas/GpuSpecificationDto","description":"GPU Specification details"}},"required":["gpuSpecification"]},"PatchAuthorizedPartyRequest":{"type":"object","description":"Request payload to associate/disassociate authorized party with function\n","properties":{"authorizedParty":{"$ref":"#/components/schemas/AuthorizedPartyDto","description":"Authorized party"}},"required":["authorizedParty"]},"ListTelemetryResponse":{"type":"object","description":"Response containing a list of telemetry configurations.","properties":{"telemetries":{"type":"array","description":"List of telemetry configurations.","items":{"$ref":"#/components/schemas/TelemetryDto"}}}},"ListRegistryCredentialDetailsResponse":{"type":"object","description":"Response body containing list of registry credentials","properties":{"registryCredentials":{"type":"array","description":"List of registry credentials","items":{"$ref":"#/components/schemas/RegistryCredentialDetailsDto"}}},"required":["registryCredentials"]},"RecognizedRegistriesResponse":{"type":"object","description":"Response body for recognized registries endpoint","properties":{"recognizedRegistries":{"type":"object","additionalProperties":{"type":"array","items":{"type":"object","additionalProperties":{"type":"string"}}},"description":"Recognized registries"}}},"GetPositionInQueueResponse":{"type":"object","description":"Request position in queue for invocation request","properties":{"functionVersionId":{"type":"string","format":"uuid","description":"Function version id"},"functionId":{"type":"string","format":"uuid","description":"Function id"},"positionInQueue":{"type":"integer","format":"int32","description":"Position of request in queue"}},"required":["functionId","functionVersionId"]},"GetQueuesResponse":{"type":"object","description":"Request queue details of all the functions with same id in an account","properties":{"functionId":{"type":"string","format":"uuid","description":"Function id"},"queues":{"type":"array","description":"Details of all the queues associated with same named functions","items":{"$ref":"#/components/schemas/QueueDto"}}},"required":["functionId","queues"]},"QueueDto":{"type":"object","description":"Data Transfer Object(DTO) representing a request queue for function version","properties":{"functionVersionId":{"type":"string","format":"uuid","description":"Function version id"},"functionName":{"type":"string","description":"Function name"},"functionStatus":{"type":"string","description":"Function status","enum":["ACTIVE","DEPLOYING","ERROR","INACTIVE","DELETED","DEGRADED","DEGRADING"]},"queueDepth":{"type":"integer","format":"int32","description":"Approximate number of messages in the request queue"}},"required":["functionName","functionStatus","functionVersionId"]},"ListFunctionsResponse":{"type":"object","description":"Response body containing list of functions","properties":{"functions":{"type":"array","description":"List of functions","items":{"$ref":"#/components/schemas/FunctionDto"}}},"required":["functions"]},"ListFunctionIdsResponse":{"type":"object","description":"Response body containing list of function ids in an account","properties":{"functionIds":{"type":"array","description":"List of function ids","items":{"type":"string","format":"uuid"}}},"required":["functionIds"]},"Cluster":{"type":"object","properties":{"k8sVersion":{"type":"string"},"id":{"type":"string"},"name":{"type":"string"}}},"ClusterGroup":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"ncaId":{"type":"string"},"authorizedNcaIds":{"type":"array","items":{"type":"string"}},"gpus":{"type":"array","items":{"$ref":"#/components/schemas/Gpu"}},"clusters":{"type":"array","items":{"$ref":"#/components/schemas/Cluster"}}}},"ClusterGroupsResponse":{"type":"object","properties":{"clusterGroups":{"type":"array","items":{"$ref":"#/components/schemas/ClusterGroup"}}}},"Gpu":{"type":"object","properties":{"name":{"type":"string"},"instanceTypes":{"type":"array","items":{"$ref":"#/components/schemas/InstanceType"}}}},"InstanceType":{"type":"object","properties":{"name":{"type":"string"},"description":{"type":"string"},"default":{"type":"boolean"}}},"ListAuthorizedPartiesResponse":{"type":"object","description":"Parties authorized to invoke function","properties":{"functions":{"type":"array","description":"Functions with authorized parties and other details","items":{"$ref":"#/components/schemas/AuthorizedPartiesByFunctionDto"}}},"required":["functions"]},"AssetDto":{"type":"object","description":"Data Transfer Object(DTO) representing an asset","properties":{"assetId":{"type":"string","format":"uuid","description":"Asset id"},"description":{"type":"string","description":"Description specified when creating the asset"},"contentType":{"type":"string","description":"Content-type specified when creating the asset"},"createdAt":{"type":"string","format":"date-time","description":"Timestamp specified when creating the asset"}}},"ListAssetsResponse":{"type":"object","description":"Response body containing list of assets of the current nca id","properties":{"assets":{"type":"array","description":"List of assets uploaded for the nca id","items":{"$ref":"#/components/schemas/AssetDto"}}}},"AssetResponse":{"type":"object","properties":{"asset":{"$ref":"#/components/schemas/AssetDto"}},"required":["asset"]},"HealthComponent":{"type":"object","propertie
[...]
